'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: Erstellt aus jedem aktuellen Abonnement mit Freigabestatus einen eigenen Beleg
' Ansicht:  FakturaAbonnement
' Script :  FakturaAbonnement_02_Aborechnung_Erzeugen.vbs
' Produkt:  combit Relationship Manager 5
' Autor  :  Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->


'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "003"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - Filter bei Rechnungslauf und fehlender Freigabe korrigiert
'--------------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------------
' Version 002
' - Stored Procedure kontrolliert ausfhren (Sicherheitsmechanismen)
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "129"
sErrorSkript    = "002"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------


'Daten fr Stored Procedure auslesen
Dim sErfUser,sRecordid

sErfUser        = Crm.CurrentProject.CurrentUser
sRecordid      = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Recordid")

If sRecordid = "" Then
  Wscript.Quit
End IF

'Testen, ob berhaupt Rechnungen mglich sind

Dim sFilterSQL,bFilter


sFilterSQL = "Select ""Factura_Abonnement"".""Recordid"" from ""Factura_Abonnement"""_
              & " inner join ""Factura_Abonnement_Protokoll"" on ""Factura_Abonnement"".""Recordid"""_
	      & " = ""Factura_Abonnement_Protokoll"".""Abonnement_Recordid"""_
	      &" where (""Factura_Abonnement_Protokoll"".""Status"" like 'Freigabe%' and"_
	      &" DATEADD(hh,24,""Factura_Abonnement_Protokoll"".""Erf_Dat"") >= Getdate() )"


bFilter = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.SetFilterDirectSQL(sFilterSQL)

  if bFilter = True then
  
    'Treffer vorhanden?
    If crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.MoveFirst then
     Showmessage("Es knnen " & cRM.CurrentProject.ActiveViews.ActiveView.FilterRecCount & " Abonnements in Rechnung gestellt werden.")
   Else
     Showmessage("Es knnen derzeit keine Abonnements in Rechnung gestellt werden. Bitte fhren Sie einen Prflauf durch.")
     'crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.SetFilter("")
     crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.SetFilter("""Factura_Abonnement"".""Recordid"" = 0x" & sRecordid)
     Wscript.Quit
     End if
  Else 
   Showmessage("Der Filter konnte nicht erstellt werden.")
   Wscript.Quit
  End if
'Stored Procedure ausfhren

Dim sProcedure, sTrennzeichen, sParameter

 sProcedure    = "Fs_Aborechnung"
 sTrennzeichen = ";"
 sParameter    =   sErfUser

'Stored Procedure kontrolliert ausfhren
  Dim bSP 

crm.StartWaitDlg "Die Rechnungen werden generiert. Dieser Vorgang kann in Abhngigkeit der Anzahl etwas dauern. ",false

  

  bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "002"))
 
   if bSP = false THEN
    'RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
    crm.EndWaitDlg
    Wscript.Quit
  End If
  
  crm.EndWaitDlg
' ----- 3. SQL Filter auf neuen Datensatz -----

'Filter auf den neu angelegten Datensatz
Dim sFilterAbolauf

sFilterAbolauf= "Select ""Factura_Abonnement"".""Recordid"" from ""Factura_Abonnement"""_
              & " inner join ""Factura_Abonnement_Protokoll"" on ""Factura_Abonnement"".""Recordid"""_
	      & " = ""Factura_Abonnement_Protokoll"".""Abonnement_Recordid"""_
	      &" where (""Factura_Abonnement_Protokoll"".""Status"" like 'Aborechnung%' and"_
	      &" DATEADD(n,5,""Factura_Abonnement_Protokoll"".""Aend_Dat"") >= Getdate() )"


SetFilterDirectSQL(sFilterAbolauf)



